﻿using DataEntity;
using PropertyChanged;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;

namespace Sklad.ViewModels
{
    [ImplementPropertyChanged]
    public class pgPrehMatVM
    {

        public pgPrehMatVM()
        {
            CollectionView view = (CollectionView)
                CollectionViewSource.GetDefaultView(MaterialyCol);
            view.Filter = UserFilter;
        }


        private bool UserFilter (object item)
        {
            if (String.IsNullOrEmpty(FiltrMaterialNazev))
                return true;
            else
                return ((item as Material).NazevMat.IndexOf(FiltrMaterialNazev,
                    StringComparison.OrdinalIgnoreCase) >= 0);
        }

        private string _filtrMaterialNazev;
        public string FiltrMaterialNazev {
            get
            {
                return _filtrMaterialNazev;
            }
            set
            {
                _filtrMaterialNazev = value;
                CollectionViewSource.GetDefaultView(MaterialyCol).Refresh();
            }
        }

        public enum Rezimy { Prohlizeni, Pridavani, Editace }

        public Rezimy AktualniRezim { get; set; } = Rezimy.Prohlizeni;

        public string AktualniRezimString
        {
            get
            {
                switch (AktualniRezim)
                {
                    case Rezimy.Pridavani: return "Přidávání";
                    case Rezimy.Editace: return "Editace";
                }
                return "Prohlížení";
            }
        }

        public bool RezimPridavaniNeboEditace
        {
            get
            {
                return AktualniRezim != Rezimy.Prohlizeni;
            }
        }

        public bool JeOznacenMaterial
        {
            get
            {
                return MaterialSelected != null;
            }
        }

      //public bool JeOznacenMaterial => MaterialSelected != null;


        private ObservableCollection<Material> _materialyCol;
        public ObservableCollection<Material> MaterialyCol {
            get
            {
                if (_materialyCol == null)
                    _materialyCol = new ObservableCollection<Material>(Globals._context.Materialy);

                return _materialyCol;
            }
            set
            {
                
                   _materialyCol = value;
            }

        }

        public Material MaterialSelected { get; set; }

    }
}
